//========================================================

class Keyboard extends Controller {

//========================================================

    //----------------------------------------------------
    connect(){
    //----------------------------------------------------

        document.addEventListener('keydown', this.onKeyPressed.bind(this));
        document.addEventListener('keyup', this.onKeyReleased.bind(this));

    }

    //----------------------------------------------------
    disconnect(){
    //----------------------------------------------------

        return true;

    }
    //----------------------------------------------------
    onKeyPressed(event){
    //----------------------------------------------------
        this.children.by_class(Key).execute("onPressed",event);
    }

    //----------------------------------------------------
    onKeyReleased(event){
    //----------------------------------------------------
        this.children.by_class(Key).execute("onRelease",event);
    }
    //----------------------------------------------------
}
//========================================================

class Key extends ControllerPart {

//========================================================

    //----------------------------------------------------
    onSetup(data){
    //----------------------------------------------------

        super.onSetup(data);
        this.add_variable("text",null);

    }
    //----------------------------------------------------
    onTest(event){
    //----------------------------------------------------

        if ( event.code == this.text){
            return true;
        }else{
            return false;
        }

    }
    //----------------------------------------------------
    onPressed(event){
    //----------------------------------------------------

          if ( this.onTest(event)==true){

            
            }

    }
    //----------------------------------------------------
    onRelease(event){
    //----------------------------------------------------

          if ( this.onTest(event)==true){

            
            }

    }
    //----------------------------------------------------
}
//========================================================


